
.include 	"tn2313adef.inc"	;  tiny2313a



.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21
.def	Temp6=R22			;  
.def	Temp7=R23			;  ,   
.def	Temp8=R24
.def	Temp9=R25


.dseg					;

OZU: .byte 40				;  40   


;******************************************************************************


.cseg			

.org 0


rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

.org INT0addr				; = 0x0001 External Interrupt Request 0

rjmp INT_0

.org INT_VECTORS_SIZE


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b00000000		;   "" (0-, 1-)
	out DDRB,Temp			; 0000000 - ""  
					; 0 - "" 
				
												 
	ldi Temp,0b00000000		;   "D" (0-, 1-)
	out DDRD,Temp 			; 00000000 -     


	RCALL	LCD_INIT		;  




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					
;	ldi R16,(1<<ISC00)		;     INT0    
;	out MCUCR,R16
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




	ldi R16,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,R16


	ldi R16,(1<<INT0)		;     INT0
	out GIMSK ,R16


	
	ldi Temp,(1<<cs10)		;    = CK 1:1 ( 1   = 0,05  )
	out TCCR1B,Temp	


	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp




	ldi R22,2			;   ( 1= , 0= , 2=  )

	ldi R23,40			;    ,   

					;   "Z"    "OZU"
	ldi ZL,	low(OZU)		;   ********************************************************()
	ldi ZH,	high(OZU)		;   


	sei				;   
	




;*******************************************************************************
;  
;*******************************************************************************




Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;  
;*******************************************************************************

INT_0:
	



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in XH,TCNT1L			;     "X"   "TCNT1" (  TCNT1    )
	in XL,TCNT1H



	ldi Temp,0			;   (  TCNT1    )
	out TCNT1H,Temp
	out TCNT1L,Temp




	rcall out_disp			;   
;----------------------------------------------------------------------------------------------------------------


	cpi R22,2			;         ?
	brne proverka_flaga_fazy	;  ,     


	ldi R16,(1<<ISC01)		;      "INT0" 
	out MCUCR,R16

	ldi R22,0			;    (0= )



	rjmp out_1			; 






proverka_flaga_fazy:

	cpi R22,1			;      ?
	brne setup_rising_edge		;  ,       


	

setup_falling_edge:			;  - "    "

	ldi R16,(1<<ISC01)		;      "INT0"
	out MCUCR,R16

	ldi R22,0			;    (0= )

;...					;     **************************************************

	rjmp obrabotka






setup_rising_edge:			;  - "    "

	ldi R16,(1<<ISC01)|(1<<ISC00)	;      "INT0"
	out MCUCR,R16

	ldi R22,1			;    (1= )


;...					;     ***********************************************

	rjmp obrabotka



;*********************************************************************************************************
; 
;*********************************************************************************************************

obrabotka:

					;   *****************************************************************
					;
					;
					;
					;     
					;  R22=0,       (     )
					;  R22=1,       (     )
					; 
					;    ,     
					;
					;
					; ....................
					; ....................




;*********************************************************************************
;  TCNT1  3300-10%=2970  ( 0xB9A )
;*********************************************************************************



	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xB			;     "Y" 3300-10%=2970  ( 0xB9A )
	ldi YL,0x9A



	rcall compare_XY16_2970		; ...

	breq X_bolshe_Y_2970		;     X=Y 
	brcs X_menshe_Y_2970		;     X<Y
	rjmp X_bolshe_Y_2970		;     X>Y 



;------------------------------------------------------------------------------------------------------------

compare_XY16_2970:

	cp Temp,YH			;    
	breq xh_eq_yh_2970		;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh_2970:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            

;*************************************************************************************************************
;   TCNT1  2970 (    )						! x<2970
;*************************************************************************************************************

X_menshe_Y_2970:			;    TCNT1  2970



	rjmp out_1			; 

;*************************************************************************************************************
;  TCNT1  2970 //      3300+10%=3630  ( 0xE2E )
;*************************************************************************************************************


X_bolshe_Y_2970:			;    TCNT1  2970




	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xE			;     "Y" 3300+10%=3630  ( 0xE2E )
	ldi YL,0x2E



	rcall compare_XY16_3630		; ...

	breq X_menshe_Y_3630		;     X=Y
	brcs X_menshe_Y_3630		;     X<Y 
	rjmp X_bolshe_Y_3630		;     X>Y 



;------------------------------------------------------------------------------------------------------------

compare_XY16_3630:

	cp Temp,YH			;    
	breq xh_eq_yh_3630		;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh_3630:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret           



;*************************************************************************************************************
;   TCNT1  2970   3630 (    3300 +/- 10% ) 				! x=3300 (_1)
;*************************************************************************************************************

X_menshe_Y_3630:			;    TCNT1  2970   3630 (    3300 +/- 10% )


;----------------------------------------------------------------

;	rcall out_disp			;   

;----------------------------------------------------------------

	ldi R16, 1
	st Z+,R16			;    _1, 
 					;     "z"    1

	dec R23				;        

	brne out_1			;    40 ,    

	rjmp chtenie_ozu		;   40,    

;*************************************************************************************************************
; TCNT1  3630 //       6600-10%=5940  ( 0x1734 )
;*************************************************************************************************************


X_bolshe_Y_3630:			;    TCNT1  3630


	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0x17			;     "Y" 6600-10%=5940  ( 0x1734 )
	ldi YL,0x34



	rcall compare_XY16_5940		; ...

	breq X_bolshe_Y_5940		;     X=Y 
	brcs X_menshe_Y_5940		;     X<Y
	rjmp X_bolshe_Y_5940		;     X>Y 



;------------------------------------------------------------------------------------------------------------

compare_XY16_5940:

	cp Temp,YH			;    
	breq xh_eq_yh_5940		;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh_5940:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            


;*************************************************************************************************************
;   TCNT1  3630   5940  (     )						! 3630<x<5940
;*************************************************************************************************************


X_menshe_Y_5940:			;  TCNT1  3630   5940




	rjmp out_1			; 


;*************************************************************************************************************
;  TCNT1  5940 //      6600+10%=7260 ( 1C5C )
;*************************************************************************************************************


X_bolshe_Y_5940:			; TCNT1  5940 //      6600+10%=7260 ( 1C5C )




	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xE			;     "Y" 3300+10%=3630  ( 0xE2E )
	ldi YL,0x2E



	rcall compare_XY16_7260		; ...

	breq X_menshe_Y_7260		;     X=Y
	brcs X_menshe_Y_7260		;     X<Y 
	rjmp X_bolshe_Y_7260		;     X>Y 



;------------------------------------------------------------------------------------------------------------

compare_XY16_7260:

	cp Temp,YH			;    
	breq xh_eq_yh_7260		;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh_7260:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret           

;*************************************************************************************************************
;   TCNT1  5940,   7260  (     6600 +/- 10% ) 				! x=6600 (_0)
;*************************************************************************************************************


X_menshe_Y_7260:

;----------------------------------------------------------------
					
;	rcall out_disp			;   

;----------------------------------------------------------------

	ldi R16, 0
	st Z+,R16			;    _0 
 					;     "Z"    1

	dec R23				;        

	brne out_1			;    40 ,    

	rjmp chtenie_ozu		;   40,    


;*************************************************************************************************************
;   TCNT1  7260 (    )								! x>7260
;*************************************************************************************************************


X_bolshe_Y_7260:



;	rjmp sbros_znachenyi

	rjmp out_1


;**************************************************************************************************************
;    
;**************************************************************************************************************

chtenie_ozu:				;   


;...........


sbros_znachenyi:			;   
					;      !



	ldi R16,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,R16



	ldi R22,2			;     

	ldi R23,40			;    ,   


					;   "Z"    "OZU"
	ldi ZL,	low(OZU)		;   ********************************************************()
	ldi ZH,	high(OZU)		;   


	rjmp out_1


;**************************************************************************************************************
;      
;**************************************************************************************************************

out_disp:

	mov r16, XL			;    TCNT1L
	push r16			;    

	mov r16, XH			;    TCNT1H
	rcall printhex			;    

	pop r16				;  



printhex:

	push r16			;   
	swap r16			;        (SWAP -   )

	rcall printhex1			;    
	pop  r16			;    


printhex1:				;  

	andi r16, 0x0f			;  00001111 (  ) 
	rcall lcd_char			;    
	ret 
	

;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	



	cpi r23,35			;       5  
	breq out_1			;    ,   ( )
	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    


;**********************************************************************************************************************

.include "lcd5110mini.asm"		;   	
	